unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ShellAPI, StdCtrls, Grids, ExtCtrls;

type
  TForm1 = class(TForm)
    Bevel1: TBevel;
    StringGrid1: TStringGrid;
    OpenDialog1: TOpenDialog;
    Button1: TButton;
    SaveDialog1: TSaveDialog;
    Button2: TButton;
    procedure Button2Click(Sender: TObject);
    procedure StringGrid1DrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
  pName : Array[0..255] of Char;
  fName : String[13];
  N : Word;
  IcoH : hIcon;
  CurItem : LongInt;
begin
  with OpenDialog1 do
    begin
      if not Execute then exit;
      fName := ExtractFilename(Filename);
      StrPCopy(pName, Filename);
    end;
    CurItem := 0;
    N := 0;
with StringGrid1 do
  repeat
    IcoH := ExtractIcon(hInstance, pName, N);
    if IcoH <= 1 then Break;
    Col := CurItem mod ColCount;
    if (CurItem div ColCount) >= RowCount then
      RowCount := RowCount + 1;
    Row := CurItem div ColCount;
    Cells[Col,Row] := fName + ' #' + IntToStr(N);
    Objects[Col, Row] := TIcon.Create;
    with Objects[Col, Row] as TIcon do
      Handle := IcoH;
      CurItem := CurItem + 1;
    N := N + 1;
  until False;
end;
procedure TForm1.StringGrid1DrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
begin
if StringGrid1.Objects[StringGrid1.Col, StringGrid1.Row] is TIcon then
  StringGrid1.Canvas.Draw(Rect.Left+56, Rect.Top+24, TIcon(StringGrid1.Objects[StringGrid1.Col, StringGrid1.Row]));
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
if SaveDialog1.Execute then
  with StringGrid1 do
    with Objects[Col,Row] as TIcon do
      SaveToFile(SaveDialog1.Filename);
end;

end.
