unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Grids, ExtCtrls;

type
  TForm1 = class(TForm)
    Bevel1: TBevel;
    DrawGrid1: TDrawGrid;
    ComboBox1: TComboBox;
    procedure ComboBox1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure DrawGrid1DrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.DrawGrid1DrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
begin
with DrawGrid1 do
  Canvas.TextRect(Rect, Rect.Left, Rect.Top, Char((Row + 1) * 32 + Col));
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
with ComboBox1 do
  begin
    Items := Screen.Fonts;
    ItemIndex := Items.IndexOf(Font.Name);
  end;
Caption := '  - ' + Font.Name;
end;

procedure TForm1.ComboBox1Click(Sender: TObject);
begin
  DrawGrid1.Font.Name := ComboBox1.Text;
  Caption := '  - ' + DrawGrid1.Font.Name;
end;

end.
